package wenrgise.hrms.ejb.facade;

import java.sql.Timestamp;
import java.util.ArrayList;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import wenrgise.common.bean.BaseHeaderBean;
import wenrgise.common.exception.EnrgiseApplicationException;
import wenrgise.common.exception.EnrgiseSystemException;
import wenrgise.common.utility.RecordMetaInfo;
import wenrgise.common.utility.UserInfo;
import wenrgise.common.vo.BaseQueryVO;
import wenrgise.common.vo.LovQueryVO;
import wenrgise.common.vo.LovVO;
import wenrgise.hrms.bean.HrmEmpDepHdrBean;
import wenrgise.hrms.bean.HrmEmpDiscActionHdrBean;
import wenrgise.hrms.bean.HrmEmpPersHdrBean;
import wenrgise.hrms.bean.HrmMisReportHdrBean;
import wenrgise.hrms.ejb.business.HrmAgeAnalysisBO;
import wenrgise.hrms.ejb.business.HrmEmpDepDtlBO;
import wenrgise.hrms.ejb.business.HrmEmpDiscActionBO;
import wenrgise.hrms.ejb.business.HrmEmpPersBO;
import wenrgise.hrms.ejb.business.HrmMisReportBO;
import wenrgise.hrms.ejb.business.HrmMyWorkflowBO;
import wenrgise.hrms.ejb.business.HrmRetireForecastBO;
import wenrgise.hrms.vo.HrmEmpDepDtlQVO;
import wenrgise.hrms.vo.HrmEmpDiscActionQVO;
import wenrgise.hrms.vo.HrmEmpPersQVO;
import wenrgise.hrms.vo.HrmMisreportQVO;
import wenrgise.hrms.vo.HrmMyWorkflowQVO;
import wenrgise.hrms.vo.HrmRetireForecastQVO;

public class HrmEmployeeMaintenanceFacadeBean implements SessionBean {
  SessionContext ctx;
  
  public void ejbCreate() {}
  
  public void ejbActivate() {}
  
  public void ejbPassivate() {}
  
  public void ejbRemove() {}
  
  public void setSessionContext(SessionContext ctx) {
    this.ctx = ctx;
  }
  
  public RecordMetaInfo getHrmEmpDepDtlHdrMetaInfo(HrmEmpDepDtlQVO oHrmEmpDepDtlQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oHrmEmpDepDtlBO = new HrmEmpDepDtlBO();
    return oHrmEmpDepDtlBO.getHrmEmpDepDtlHdrMetaInfo(oHrmEmpDepDtlQVO);
  }
  
  public ArrayList getHrmEmpDepDtlHdrInfo(HrmEmpDepDtlQVO oHrmEmpDepDtlQVO, long lStartPosition, long lLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oHrmEmpDepDtlBO = new HrmEmpDepDtlBO();
    return oHrmEmpDepDtlBO.getHrmEmpDepDtlHdrInfo(oHrmEmpDepDtlQVO, lStartPosition, lLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpDepDtlMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oHrmEmpDepDtlBO = new HrmEmpDepDtlBO();
    return oHrmEmpDepDtlBO.getHrmEmpDepDtlMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpDepDtlInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oHrmEmpDepDtlBO = new HrmEmpDepDtlBO();
    return oHrmEmpDepDtlBO.getHrmEmpDepDtlInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public String saveData(HrmEmpDepHdrBean oHrmEmpDepHdrBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked, UserInfo oUserInfo) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmEmpDepDtlBO oHrmEmpDepDtlBO = new HrmEmpDepDtlBO(oUserInfo);
      return oHrmEmpDepDtlBO.saveData((BaseHeaderBean)oHrmEmpDepHdrBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public LovVO getHrmEmpDepDtlEmpNoLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oBO = new HrmEmpDepDtlBO();
    LovVO oLovVO = oBO.getHrmEmpDepDtlEmpNoLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmplDepRelTypeLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDepDtlBO oBO = new HrmEmpDepDtlBO();
    LovVO oLovVO = oBO.getHrmEmpDepDtlRelTypeLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpDiscActionHdrMetaInfo(HrmEmpDiscActionQVO oHrmEmpDiscActionQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDiscActionBO oHrmEmpDiscActionBO = new HrmEmpDiscActionBO();
    return oHrmEmpDiscActionBO.getHrmEmpDiscActionHdrMetaInfo(oHrmEmpDiscActionQVO);
  }
  
  public ArrayList getHrmEmpDiscActionHdrInfo(HrmEmpDiscActionQVO oHrmEmpDiscActionQVO, long lStartPosition, long lLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDiscActionBO oHrmEmpDiscActionBO = new HrmEmpDiscActionBO();
    return oHrmEmpDiscActionBO.getHrmEmpDiscActionHdrInfo(oHrmEmpDiscActionQVO, lStartPosition, lLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpDiscActionMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDiscActionBO oHrmEmpDiscActionBO = new HrmEmpDiscActionBO();
    return oHrmEmpDiscActionBO.getHrmEmpDiscActionMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpDiscActionInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDiscActionBO oHrmEmpDiscActionBO = new HrmEmpDiscActionBO();
    return oHrmEmpDiscActionBO.getHrmEmpDiscActionInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public String saveData(HrmEmpDiscActionHdrBean oHrmEmpDiscActionHdrBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked, UserInfo oUserInfo) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmEmpDiscActionBO oHrmEmpDiscActionBO = new HrmEmpDiscActionBO(oUserInfo);
      return oHrmEmpDiscActionBO.saveData((BaseHeaderBean)oHrmEmpDiscActionHdrBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public LovVO getHrmEmpDiscActionSiteLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpDiscActionBO oBO = new HrmEmpDiscActionBO();
    LovVO oLovVO = oBO.getHrmEmpDiscActionSiteLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersHdrMetaInfo(HrmEmpPersQVO oHrmEmpPersQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersHdrMetaInfo(oHrmEmpPersQVO);
  }
  
  public ArrayList getHrmEmpPersHdrInfo(HrmEmpPersQVO oHrmEmpPersQVO, long lStartPosition, long lLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersHdrInfo(oHrmEmpPersQVO, lStartPosition, lLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersDtlsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersDtlsMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersDtlsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersDtlsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public String saveData(HrmEmpPersHdrBean oHrmEmpPersHdrBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked, UserInfo oUserInfo) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO(oUserInfo);
      return oHrmEmpPersBO.saveData((BaseHeaderBean)oHrmEmpPersHdrBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public LovVO getHrmEmpPersDtlsEmpNoLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsEmpNoLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsMotTngLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsMotTngLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsNationalityLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsNationalityLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsMaritalStatusLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsMaritalStatusLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsDeptLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsDeptLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsDesigLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsDesigLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsSocialStatusLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsSocialStatusLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsReligionLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsReligionLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsGradeLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsGradeLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsRepEmpLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsRepEmpLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersDtlsRelatedEmpLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersDtlsRelatedEmpLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersAddDtlsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersAddDtlsMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmPersAddDtlsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmPersAddDtlsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getHrmEmpPersAddDtlsStateLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersAddDtlsStateLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersAddDtlsCountryLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersAddDtlsCountryLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersAddDtlsDistrictLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersAddDtlsDistrictLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersAddDtlsTehsilLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersAddDtlsTehsilLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersJoinInfMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersJoinInfMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersJoinInfInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersJoinInfInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getHrmEmpPersJoinInfBaseSiteLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfBaseSiteLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfEntryLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfEntryLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfStatusLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfStatusLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfSepTypeLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfSepTypeLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfCostCentreLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfCostCentreLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfBankLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfBankLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersJoinInfJobRespLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersJoinInfJobRespLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersPriorExpMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersPriorExpMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersPriorExpInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersPriorExpInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getHrmEmpPersPriorExpSkillLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersPriorExpSkillLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersPriorExpDesigLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersPriorExpDesigLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersEduDtlsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersEduDtlsMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersEduDtlsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersEduDtlsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getHrmEmpPersEduDtlsInstLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersEduDtlsInstLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public LovVO getHrmEmpPersEduDtlsQualLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmEmpPersEduDtlsQualLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersEmpHistMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersEmpHistMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersEmpHistInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersEmpHistInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersPFDtlsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPerPFDtlMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersPFDtlsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersPFDtlsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getHrmRelationLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oPersDtl = new HrmEmpPersBO();
    LovVO oLovVO = oPersDtl.getHrmRelationLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersTrngDtlsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersTrngDtlsMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersTrngDtlsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersTrngDtlsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersAwardMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersAwardMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersAwardInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersAwardInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersInsMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersInsMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersInsInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersInsInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersHealthMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersHealthMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersHealthInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersHealthInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersLngMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersLngMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersLngInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersLngInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public RecordMetaInfo getHrmEmpPersRefMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersRefMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersRefInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersRefInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public LovVO getMisPositionLOVData(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
    LovVO oLovVO = oHrmMisReportBO.getMisPositionLOVData(oLovQueryVO);
    return oLovVO;
  }
  
  public String InsertData(HrmMisReportHdrBean oHrmMisReportHdrBean, ArrayList oDetailBeanArray) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
      return oHrmMisReportBO.InsertData((BaseHeaderBean)oHrmMisReportHdrBean, oDetailBeanArray);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public RecordMetaInfo getMisDataCount(HrmMisreportQVO oHrmMisreportQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
    return oHrmMisReportBO.getMisDataCount(oHrmMisreportQVO);
  }
  
  public ArrayList getMisDataInfo(HrmMisreportQVO oHrmMisreportQVO, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
    return oHrmMisReportBO.getMisDataInfo(oHrmMisreportQVO, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public String saveHrmMisData(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked, UserInfo oUserInfo) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO(oUserInfo);
    return oHrmMisReportBO.saveData(oBaseHeaderBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked);
  }
  
  public LovVO getMisYearMonthLOVData(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
    LovVO oLovVO = oHrmMisReportBO.getMisYearMonthLOVData(oLovQueryVO);
    return oLovVO;
  }
  
  public String getYearMonth() throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmMisReportBO oHrmMisReportBO = new HrmMisReportBO();
      return oHrmMisReportBO.getYearMonth();
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public String InsertData(BaseHeaderBean oBaseHeaderBean) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmRetireForecastBO oHrmRetireForecastBO = new HrmRetireForecastBO();
      return oHrmRetireForecastBO.InsertData(oBaseHeaderBean);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public RecordMetaInfo procGetRetireDataCount(HrmRetireForecastQVO oHrmRetireForecastQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmRetireForecastBO oHrmRetireForecastBO = new HrmRetireForecastBO();
    return oHrmRetireForecastBO.procGetRetireDataCount(oHrmRetireForecastQVO);
  }
  
  public ArrayList procGetRetireDataInfo(HrmRetireForecastQVO oHrmRetireForecastQVO, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmRetireForecastBO oHrmRetireForecastBO = new HrmRetireForecastBO();
    return oHrmRetireForecastBO.procGetRetireDataInfo(oHrmRetireForecastQVO, lDetailFirstPosition, lDetailLastPosition);
  }
  
  public String saveHrmRetireForecastData(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked, UserInfo oUserInfo) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmRetireForecastBO oHrmRetireForecastBO = new HrmRetireForecastBO(oUserInfo);
    return oHrmRetireForecastBO.saveData(oBaseHeaderBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked);
  }
  
  public String InsertDataAgeAnalysis(BaseHeaderBean oBaseHeaderBean) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmAgeAnalysisBO oHrmAgeAnalysisBO = new HrmAgeAnalysisBO();
      return oHrmAgeAnalysisBO.InsertDataAgeAnalysis(oBaseHeaderBean);
    } catch (EnrgiseSystemException oSysEx) {
      this.ctx.setRollbackOnly();
      throw oSysEx;
    } catch (EnrgiseApplicationException oAppEx) {
      this.ctx.setRollbackOnly();
      throw oAppEx;
    } 
  }
  
  public RecordMetaInfo getHrmMyWorkflowHdrMetaInfo(HrmMyWorkflowQVO oHrmMyWorkflowQVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMyWorkflowBO oHrmMyWorkflowBO = new HrmMyWorkflowBO();
    return oHrmMyWorkflowBO.getHrmMyWorkflowHdrMetaInfo(oHrmMyWorkflowQVO);
  }
  
  public ArrayList getHrmMyWorkflowHdrInfo(HrmMyWorkflowQVO oHrmMyWorkflowQVO, long lStartPosition, long lLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMyWorkflowBO oHrmMyWorkflowBO = new HrmMyWorkflowBO();
    return oHrmMyWorkflowBO.getHrmMyWorkflowHdrInfo(oHrmMyWorkflowQVO, lStartPosition, lLastPosition);
  }
  
  public RecordMetaInfo getHrmMyWorkflowDetailMetaInfo(BaseQueryVO oBaseQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMyWorkflowBO oHrmMyWorkflowBO = new HrmMyWorkflowBO();
    return oHrmMyWorkflowBO.getHrmMyWorkflowDetailMetaInfo(oBaseQueryVO);
  }
  
  public ArrayList getHrmMyWorkflowDetailInfo(BaseQueryVO oBaseQueryVO, long lStartPosition, long lLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMyWorkflowBO oHrmMyWorkflowBO = new HrmMyWorkflowBO();
    return oHrmMyWorkflowBO.getHrmMyWorkflowDetailInfo(oBaseQueryVO, lStartPosition, lLastPosition);
  }
  
  public LovVO getWorkIdLOVdata(LovQueryVO oLovQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmMyWorkflowBO oHrmMyWorkflowBO = new HrmMyWorkflowBO();
    LovVO oLovVO = oHrmMyWorkflowBO.getWorkIdLOVdata(oLovQueryVO);
    return oLovVO;
  }
  
  public RecordMetaInfo getHrmEmpPersAssetMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersAssetMetaInfo(lPrimaryKey);
  }
  
  public ArrayList getHrmEmpPersAssetInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    HrmEmpPersBO oHrmEmpPersBO = new HrmEmpPersBO();
    return oHrmEmpPersBO.getHrmEmpPersAssetInfo(lPrimaryKey, lDetailFirstPosition, lDetailLastPosition);
  }
}
